# Time-based

{% hint style="success" %}
This is the official documentation of the `forestadmin-agent-django` and `forestadmin-agent-flask` Python agents.
{% endhint %}

![Time-based Chart example](/files/xOoZpPRHOsaoHnj3d8Cf)

Time-based charts are very similar to distribution charts, the only differences being that:

* An additional parameter tells the frontend if the dates should be displayed by `Day`, `Week`, `Month`, or `Year`,
* The keys of the returned object can be ISO-8601 compliant string dates, python `datetime.date` object, or python `datetime.datetime` object.

```python
from datetime import date, datetime
from forestadmin.datasource_toolkit.context.agent_context import AgentCustomizationContext
from forestadmin.datasource_toolkit.decorators.chart.result_builder import ResultBuilder
from forestadmin.datasource_toolkit.interfaces.chart import Chart

async def transaction_volume_chart_fn(
    context: AgentCustomizationContext, result_builder: ResultBuilder
) -> Chart:
    return result_builder.timeBased(
        "Month",
        {
            '2017-02-01': 636,
            date(2017, 3, 1): 740,
            datetime(2017, 4, 1, 0, 0): 648,
            '2017-05-01': 726,
    })

agent.add_chart("transactionVolume", transaction_volume_chart_fn)
```

If you want to add several lines to the same chart, you can use the `multiple_time_based` method:

```python
from datetime import date, datetime
from forestadmin.datasource_toolkit.context.agent_context import AgentCustomizationContext
from forestadmin.datasource_toolkit.decorators.chart.result_builder import ResultBuilder
from forestadmin.datasource_toolkit.interfaces.chart import Chart

async def new_users_by_project(
    context: AgentCustomizationContext, result_builder: ResultBuilder
) -> Chart:
      # [...]

      return result_builder.multipleTimeBased(
          "Month"
          [
              date(2017, 2, 28),
              datetime(2017, 3, 28),
              '2017-04-28',
              '2017-05-28',
          ],
          [
              {"label": 'Project 1', "values": [636, 740, 648, 726]},
              {"label": 'Project 2', "values": [100, 200, 300, 400]},
          ],
      )

agent.add_chart('newUsersByProject', new_users_by_project)
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-python/agent-customization/charts/time.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
